您的位置:首页 > 其它

HDU-4472-Count (2012 ACM/ICPC成都现场赛)

2014-11-26 20:37 274 查看


Count

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 1850 Accepted Submission(s): 1200



Problem Description

Prof. Tigris is the head of an archaeological team who is currently in charge of an excavation in a site of ancient relics.

This site contains relics of a village where civilization once flourished. One night, examining a writing record, you find some text meaningful to you. It reads as follows.

“Our village is of glory and harmony. Our relationships are constructed in such a way that everyone except the village headman has exactly one direct boss and nobody will be the boss of himself, the boss of boss of himself, etc. Everyone expect the headman
is considered as his boss’s subordinate. We call it relationship configuration. The village headman is at level 0, his subordinates are at level 1, and his subordinates’ subordinates are at level 2, etc. Our relationship configuration is harmonious because
all people at same level have the same number of subordinates. Therefore our relationship is …”

The record ends here. Prof. Tigris now wonder how many different harmonious relationship configurations can exist. He only cares about the holistic shape of configuration, so two configurations are considered identical if and only if there’s a bijection of
n people that transforms one configuration into another one.

Please see the illustrations below for explanation when n = 2 and n = 4.



The result might be very large, so you should take module operation with modules 109 +7 before print your answer.



Input

There are several test cases.

For each test case there is a single line containing only one integer n (1 ≤ n ≤ 1000).

Input is terminated by EOF.



Output

For each test case, output one line “Case X: Y” where X is the test case number (starting from 1) and Y is the desired answer.



Sample Input

1
2
3
40
50
600
700




Sample Output

Case 1: 1
Case 2: 1
Case 3: 2
Case 4: 924
Case 5: 1998
Case 6: 315478277
Case 7: 825219749




Source

2012 Asia Chengdu Regional Contest



题意:去找有多少种树,使得同一层的节点的度要一致

思路:简单DP

AC代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

int dp[1010] = {0,1,1,2,3};
const int maxn = 1000000007;

void init()
{
	for(int i=5; i<=1000; i++)
	{
		for(int j=1; j<i; j++)
		{
			if((i-1)%j==0)
			{
				dp[i] += dp[j];
				dp[i] %= maxn;
			}
		}
	}
} 

int main()
{
	init();
	int n, k=1;
	while(~scanf("%d", &n))
	{
		printf("Case %d: %d\n", k, dp
);
		k++;
	}
	return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: